import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class jVisCalculateWindow extends JFrame{

    private jVisSpektrumEntity spektrum; //entpricht ehemaliges Vector output
                                            //enthaelt ehemaliges String outputKopplungsmuster

    private Vector ppm;		//Speichert die eingegebenen ppm bzw. MHz-Werte

    private jVisSpektrumViewPanel abbildung;
    private JComboBox wertmhz;
    private JRadioButton einheitmhz;
    private JRadioButton einheitppm;
    private JLabel measurementAt;
    private JLabel mhz;
    private JButton berechnen;
    
    
public jVisCalculateWindow(jVisSpektrumEntity wse){
    
    super(jVisualizer.programmtitel + ", Calculate");
    spektrum = wse;    

    //Grundeinstellungen zum Fenster
    setSize(470,530);
    getContentPane().setLayout( new BorderLayout() );
    setDefaultCloseOperation(DISPOSE_ON_CLOSE);


    //Darstellung des Spektrums
    abbildung = new jVisSpektrumViewPanel(spektrum);
    JPanel abbildungsPanel = new JPanel();
    abbildungsPanel.add(abbildung);
    getContentPane().add(abbildungsPanel,"North");


    //Calculate Constants-Button
    JPanel buttonPanel = new JPanel();
    berechnen = new JButton("Calculate Constants");
    berechnen.addActionListener( new ActionListener(){
        public void actionPerformed( ActionEvent ae ){
            calculate();
        }
    });
    berechnen.setEnabled(false);
    buttonPanel.add(berechnen, "South");


    //Angaben in ppm oder MHz?
    String[] wertelistemhz = {"599.08", "400.14", "360.14", "300.14", "282.41", "100.61", "90.57", "75.47" };
    wertmhz = new JComboBox(wertelistemhz);
    wertmhz.setSelectedIndex(2);
    wertmhz.setEnabled(false);

    einheitmhz = new JRadioButton("[MHz]");
    einheitmhz.setSelected(false);
    einheitmhz.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent e){
            measurementAt.setEnabled(false);
            wertmhz.setEnabled(false);
            mhz.setEnabled(false);
            berechnen.setEnabled(true);
        }
    });
    einheitppm = new JRadioButton("[ppm]");
    einheitppm.setSelected(false);
    einheitppm.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent e){
            measurementAt.setEnabled(true);
            wertmhz.setEnabled(true);
            mhz.setEnabled(true);
            berechnen.setEnabled(true);
        }
    });


    ButtonGroup mhzppm = new ButtonGroup();
    mhzppm.add(einheitmhz);
    mhzppm.add(einheitppm);

    JPanel northPanel = new JPanel();
    northPanel.add(einheitmhz);
    northPanel.add(new JLabel("   "));
    northPanel.add(einheitppm);
    
    measurementAt = new JLabel ("  Measured at");
    measurementAt.setEnabled(false);
    mhz = new JLabel("MHz");
    mhz.setEnabled(false);
    
    northPanel.add(measurementAt);
    northPanel.add(wertmhz);
    northPanel.add(mhz);
		
		
    //Scrollflaeche fuer Kopplungsbild und Eingabefelder vorbereiten
    JPanel scrollPanel = new JPanel();
    scrollPanel.setLayout( new BoxLayout(scrollPanel,BoxLayout.Y_AXIS) );
    JScrollPane scrollPane = new JScrollPane(scrollPanel,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    getContentPane().add(scrollPane,"Center");


    //Aufbau der JText-Felder zur ppm-Eingabe
    ppm = new Vector();
    for (int i = 0; i < spektrum.getAnzPeaks(); i++){
        JTextField eingabefeld = new JTextField(10);
        eingabefeld.setMinimumSize(eingabefeld.getPreferredSize() );
        ppm.addElement(eingabefeld);

        JPanel tempPanel = new JPanel();
        tempPanel.setLayout( new FlowLayout(FlowLayout.LEFT) );
        tempPanel.add(eingabefeld);
        tempPanel.add(new JLabel("signal " + (i+1) + " "));
        tempPanel.add(new JLabel("(\"" + ((jVisPeakEntity)spektrum.getPeak(i)).getKennungen() + "\")"));
        
        scrollPanel.add(tempPanel);
    }// for
    scrollPanel.add(Box.createVerticalGlue());
    scrollPanel.add(Box.createVerticalGlue());
    scrollPanel.add(Box.createVerticalGlue());
    scrollPanel.add(Box.createVerticalGlue());
    scrollPanel.add(Box.createVerticalGlue());


				
    JPanel southPanel = new JPanel();
    southPanel.setLayout(new BorderLayout());
    southPanel.add(buttonPanel,"South");
    southPanel.add(northPanel,"Center");
    getContentPane().add(southPanel, "South");

    setVisible(true);

}

private void calculate(){
    try{	
        //Mittelwertspeicher fr Signalmittel-Ermittlung
        jVisAverage signalmitte = new jVisAverage();
		
        for (int i = 0; i < spektrum.getAnzPeaks(); i++){
            signalmitte.add(  (Float.valueOf(  ((JTextField)ppm.elementAt(i)).getText().replace(',','.')   )  ).floatValue()  );
        }// for 	
	
        
        //Initialisieren der Mittelwert-Speicher fr die einzelnen Kopplungen
        int anzahlKopplungen = ((jVisPeakEntity) spektrum.getPeak(0)).getKennungslaenge();
        char[] kopplungsmuster = (spektrum.getKopplungsmuster()).toCharArray();

        jVisAverage[] mittelwert = new jVisAverage[anzahlKopplungen];
        jVisAverage[] dtqmittelwert = new jVisAverage[(spektrum.getKopplungsmuster()).length()];
		
        int p = 0;
        int h = 0;
        int f = 0;
        
        while (p < anzahlKopplungen){
            if ( kopplungsmuster[f] == 'd' ){
                dtqmittelwert[f] = new jVisAverage();
                mittelwert[p] = dtqmittelwert[f];
                f++;
                p++;
            }
            else if  ( kopplungsmuster[f] == 't' ){
                if ( h == 0 ){ 
                    dtqmittelwert[f] = new jVisAverage();
                    mittelwert[p] = dtqmittelwert[f];
                    p++;
                    h++;
                }	
                else if ( h == 1 ){
                    mittelwert[p] = dtqmittelwert[f];
                    h = 0;
                    p++;
                    f++;
                }
            }
            else if  ( kopplungsmuster[f] == 'q' ){
                if ( h == 0 ){ 
                    dtqmittelwert[f] = new jVisAverage();
                    mittelwert[p] = dtqmittelwert[f];
                    p++;
                    h++;
                }	
                else if ( h == 1 ){
                    mittelwert[p] = dtqmittelwert[f];
                    p++;
                    h++;
                }
                else if ( h == 2 ){
                    mittelwert[p] = dtqmittelwert[f];
                    h = 0;
                    p++;
                    f++;
                }
                    
            }
        };	
			
						
				
        //Erstellen der Laufvariable
        String links = "";
        String ende  = "";
        for (int i = 0; i < anzahlKopplungen; i++){
            links += "1";
            ende  += "2";
        };
        String rechts;
        float linksWert = 0;
        float rechtsWert = 0;

        while( !links.equals(ende) ){
        //Wiederholen bis links von "1111" bis "2222" durchgelaufen ist
			
            //alle rechten Partner von links ermitteln
            for (int y = 0; y < links.length(); y++){
                if (links.charAt(y) == '1'){
                    char[] rechtsTemp = links.toCharArray();
                    rechtsTemp[y] = '2';
                    rechts = new String(rechtsTemp);

                    boolean linksGefunden = false;
                    boolean rechtsGefunden = false;

                    int g = 0;
                    while( !linksGefunden || !rechtsGefunden ){
						
                        float wert = (Float.valueOf(  ((JTextField)ppm.elementAt(g)).getText().replace(',','.')   )  ).floatValue();
                        if ( ((jVisPeakEntity)spektrum.getPeak(g)).equals(links) ){
                            linksWert =   wert;  
                            linksGefunden = true;
                        }
                        if ( ((jVisPeakEntity)spektrum.getPeak(g)).equals(rechts) ){
                            rechtsWert = wert;
                            rechtsGefunden = true;
                        }
                        g++;
                    } // while

                    mittelwert[y].add(linksWert-rechtsWert);
                } // if
            } // for

            //links "erhoehen"
            char[] linksTemp = links.toCharArray();
            boolean fertig = false;
            int x = links.length() - 1;

            while (!fertig && x >= 0){
                        
                if (linksTemp[x] == '1'){
                    linksTemp[x] = '2';
                    fertig = true;
                }
                else{
                    linksTemp[x] = '1';
                }
                x--;
            }
            links = new String(linksTemp);

        } // while
		
		
        //String ausgabe fr Dialogausgabe erzeugen aus mittelwert[w]
        String ausgabe = new String();
        

        //Mittelwerte
        ausgabe += "The following coupling constants have been determined:\n";
		
        for (int w = 0; w < (spektrum.getKopplungsmuster()).length(); w++){
            ausgabe += "\n" + kopplungsmuster[w] + "   ";
            if ( einheitppm.isSelected() ){
                ausgabe +=  ((int)(Math.abs( (dtqmittelwert[w].getAverage()) 
                            * 
                            (   (Float.valueOf(  (String)wertmhz.getSelectedItem()  )    ).floatValue()  ) )*100)/100.0)
                            +  " Hz  ( " + ((int)(Math.abs( (dtqmittelwert[w].getDegression())				
                            * 
                            (   (Float.valueOf(  (String)wertmhz.getSelectedItem()  )).floatValue()     )				
                            )*100)/100.0) + " Hz, n = "+dtqmittelwert[w].countElements()+")";
            }
            else{
                ausgabe +=  ((int)(Math.abs( 
                            dtqmittelwert[w].getAverage()    )*100)/100.0)
                            +  " Hz  ( " + ((int)(Math.abs(		
                            dtqmittelwert[w].getDegression()	)*100)/100.0)  
                            + " Hz, n = "+dtqmittelwert[w].countElements()+")";
            }
        }


        //Signalmittel
        ausgabe += "\n\nPattern Centre at " + ((int)(Math.abs( signalmitte.getAverage()  )*100)/100.0);
        if ( einheitppm.isSelected() ){
            ausgabe += " ppm\n";
        }
        else {
            ausgabe += " MHz\n";
        }
		
		
        //JDialog mit Kopplungskonstanten darstellen
        JOptionPane.showMessageDialog(this, ausgabe, jVisualizer.programmtitel+ ", Results",JOptionPane.INFORMATION_MESSAGE);
	
    }
    catch(NumberFormatException nfe){
	JOptionPane.showMessageDialog(this, "Error\n\nPlease fill in chemical shifts for each signal. \nAlso take care about the right form\n(e.g. 1.234 or 1,234).", "Error", JOptionPane.WARNING_MESSAGE);
    }
    catch(Exception e){
	JOptionPane.showMessageDialog(this, "Error\n" + e.toString(), "Error", JOptionPane.WARNING_MESSAGE);
    }

} // calculate()

}
