import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class jVisSpektrumViewPanel extends JPanel{

    private JPanel 				darstellung;
    private jVisSpektrumPatternInfo 	information;
    private JScrollBar				skalierung;
    private jVisSpektrumEntity 		spektrum;

    private final int BREITE = 401;
    private final int HOEHE = 128;
    

public jVisSpektrumViewPanel(jVisSpektrumEntity wsp){

    spektrum = wsp;
    
    skalierung = new JScrollBar(JScrollBar.VERTICAL, 400,1,0,401);
    skalierung.setBlockIncrement(40);
    skalierung.setPreferredSize(new Dimension(skalierung.getPreferredSize().width,HOEHE));
    skalierung.setMinimumSize(skalierung.getPreferredSize());
    skalierung.setMaximumSize(skalierung.getPreferredSize());
    skalierung.addAdjustmentListener( new AdjustmentListener(){
        public void adjustmentValueChanged(AdjustmentEvent e){
            darstellung.repaint();
        }
    });
    //skalierung.setToolTipText("Vertikale Skalierung");

    information = new jVisSpektrumPatternInfo();
    information.setjVisSpektrumEntity(spektrum);
    //information.setToolTipText("Informationen zum Kopplungsmuster");

    darstellung = new JPanel(){
        public void paintComponent(Graphics g){
            //white background
            g.setColor(Color.white);
            g.fillRect(0,0,BREITE,HOEHE);

            //drawing
            //g.translate((int) BREITE/2, (int) HOEHE);
            g.setColor(Color.black);
            double teil = (HOEHE / (  Math.pow(2,(spektrum.getPeak(0)).getKennungslaenge() ) ));
            double faktor = (500.0 - skalierung.getValue())/100.0; 
				
            for (int i = 0; i < spektrum.getAnzPeaks() ; i++){
                g.drawLine(
                (spektrum.getPeak(i)).getVerschiebung() + (int) BREITE/2, 
                HOEHE, 
                (spektrum.getPeak(i)).getVerschiebung() + (int) BREITE/2, 
                HOEHE - (int)(  teil * (spektrum.getPeak(i)).getAnzKennungen()  * faktor  ) 
                );
            };
        }
    };
    darstellung.setPreferredSize(new Dimension(BREITE,HOEHE));
    darstellung.setMinimumSize(new Dimension(BREITE,HOEHE));
    darstellung.setMaximumSize(new Dimension(BREITE,HOEHE));
    //darstellung.setToolTipText("Graphische Darstellung des Signalmusters");

    setLayout(new BorderLayout());
    add(skalierung,"West");
    add(darstellung,"Center");
    add(information,"South");

} // Konstruktor jVisSpektrumViewPanel()


public void setjVisSpektrumEntity(jVisSpektrumEntity newjVisSpektrumEntity){
    spektrum = newjVisSpektrumEntity;
    darstellung.repaint();
    information.setjVisSpektrumEntity(spektrum);
}    
   
    

} // class
